unit uTrataErro;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, DBTables, DB;

type
  TForm1 = class(TForm)
    Label9: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Label1: TLabel;
    Database1: TDatabase;
    procedure FormCreate(Sender: TObject);
    procedure Edit1Exit(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    procedure ShowException(Sender: TObject; E: Exception);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
   // Utilize o OnCreate do form principal para configurar Application.
   // Entre as configuraes mais comuns temos:

   // ** Designar a procedure de tratamento de erros
   Application.OnException := ShowException;
end;

procedure TForm1.ShowException(Sender: TObject; E: Exception);
var
   cValue: string;
begin
   // Todo e qq erro que ocorrer no aplicativo, passar por aqui
   if E is EConvertError then // Erros de converso
   begin
      // O truque  testar trechos fixos das mensagems
      if pos('not a valid date', EConvertError(E).Message) <> 0 then
      begin
         // Aqui eu verifiquei que da 1a. posio at o primeiro espao, esta o
         // dado digitado. Isto muda de msg para msg
         cValue := copy(EConvertError(E).Message, 1, pos(#32, EConvertError(E).Message));
         ShowMessage('A data '+ cValue + ' que foi informada, no  vlida. Favor informa-la novamente');
         TWinControl(Sender).SetFocus;
      end else
         // Tratamento padro
         Application.ShowException(E);
   end else if E is EDatabaseError then // Erros de DB
   begin
      if pos('name missing', EDatabaseError(E).Message) <> 0 then
      begin
         // Aqui eu verifiquei que da 1a. posio at os dois pontos (:), esta o
         // nome do componente. Isto muda de msg para msg
         cValue := copy(EDatabaseError(E).Message, 1, pos(':', EDatabaseError(E).Message)-1);
         ShowMessage('O componente '+ cValue + ', esta com o nome de banco de dados errado.'+#13+
                     'O sistema ser encerrado ao acionar o boto OK');
         Application.Terminate; // Terminou porque o erro  grave, por exemplo
      end else
         // Tratamento padro
         Application.ShowException(E);
   end else
      // Tratamento padro
      Application.ShowException(E);
end;

procedure TForm1.Edit1Exit(Sender: TObject);
begin
   // Tenta converter o texto digitado para uma data, assim validamos a data
   StrToDate(Edit1.Text);
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
   // Abre o banco de dados, como as propriedades no foram ajustadas ocorrer
   // um erro que ser tratado pela rotina genrica
   Database1.Open;
end;

end.
